<?php
/*
* Decimal Product Quantity for WooCommerce PRO
* Admin Product Setup Page.
* admin_setup_product.php
*/

	/* WooCommerce Product Setup Page. | Вкладка "General"
	 * Добавляем опции: "Mинимальное / Максимальное кол-во Товара, Шаг изменения кол-ва и Количество по-умалчанию".
	 * Если не указано, то будет как в Глобальных Настройках.
	----------------------------------------------------------------- */		
	add_action ('woocommerce_product_options_general_product_data', 'WooDecimalProductPro_Tab_General_add_Options');	
	function WooDecimalProductPro_Tab_General_add_Options() {
		global $WooDecimalProduct_Min_Quantity_Default;
        global $WooDecimalProduct_Step_Quantity_Default; 
		global $WooDecimalProduct_Item_Quantity_Default;
		global $WooDecimalProduct_Max_Quantity_Default;
		
		echo '<div class="options_group">';
 		echo '<div style="margin-top: 10px; margin-left: 10px;"><span style="font-weight: bold;">Quantity Options</span><span style="margin-left: 10px;">(* If not specified, it will be as in <a target="_blank" href="/wp-admin/edit.php?post_type=product&page=decimal-product-quantity-for-woocommerce-pro/includes/options.php">Global Settings.</a>)</span></div>';
		
		woocommerce_wp_text_input( 
			array( 
				'id'          => 'woodecimalproduct_min_qnt', 
				'label'       => 'Minimum', 
				'placeholder' => $WooDecimalProduct_Min_Quantity_Default,
				'desc_tip'    => 'true',
				'description' => "Set the Min of changing the quantity: 0.1 0.5 100 e.t.c (Default = $WooDecimalProduct_Min_Quantity_Default)"
			)
		);
		
		woocommerce_wp_text_input( 
			array( 
				'id'          => 'woodecimalproduct_item_qnt', 
				'label'       => 'Default Set', 
				'placeholder' => $WooDecimalProduct_Item_Quantity_Default,
				'desc_tip'    => 'true',
				'description' => "Set the Default quantity: 0.1 0.5 100 e.t.c (Default = $WooDecimalProduct_Item_Quantity_Default)"
            )
		);		

		woocommerce_wp_text_input( 
			array( 
				'id'          => 'woodecimalproduct_step_qnt', 
				'label'       => 'Step change +/-', 
				'placeholder' => $WooDecimalProduct_Step_Quantity_Default,
				'desc_tip'    => 'true',
				'description' => "Set the Step of changing the quantity: 0.1 0.5 100 e.t.c (Default = $WooDecimalProduct_Step_Quantity_Default)"
            )
		);

		woocommerce_wp_text_input( 
			array( 
				'id'          => 'woodecimalproduct_max_qnt', 
				'label'       => 'Maximum', 
				'placeholder' => $WooDecimalProduct_Max_Quantity_Default,
				'desc_tip'    => 'true',
				'description' => "Set the Max of changing the quantity: 0.1 0.5 100 e.t.c (or leave blank)"
			)
		);
		
		echo '</div>'; 		
	}
	
	/* Сохраняем "Шаг изменения кол-ва Товара" для данного Товара.
	----------------------------------------------------------------- */		
	add_action ('woocommerce_process_product_meta', 'WooDecimalProductPro_save_product_field_step_Qnt');    
	function WooDecimalProductPro_save_product_field_step_Qnt ($post_id) {
        $new_min_Qnt     = isset($_POST['woodecimalproduct_min_qnt']) ? sanitize_text_field ($_POST['woodecimalproduct_min_qnt']): 1;
        $new_step_Qnt    = isset($_POST['woodecimalproduct_step_qnt']) ? sanitize_text_field ($_POST['woodecimalproduct_step_qnt']): 1;
		$new_dft_Qnt     = isset($_POST['woodecimalproduct_item_qnt']) ? sanitize_text_field ($_POST['woodecimalproduct_item_qnt']): 1;    
		$new_max_Qnt     = isset($_POST['woodecimalproduct_max_qnt']) ? sanitize_text_field ($_POST['woodecimalproduct_max_qnt']): '';		
		
		update_post_meta($post_id, 'woodecimalproduct_min_qnt', $new_min_Qnt);
		update_post_meta($post_id, 'woodecimalproduct_step_qnt', $new_step_Qnt);
		update_post_meta($post_id, 'woodecimalproduct_item_qnt', $new_dft_Qnt);	
		update_post_meta($post_id, 'woodecimalproduct_max_qnt', $new_max_Qnt);		
	}

    /* Вариативный Товар. Админка. Шаг и Минимальное кол-во выбора Товара на странице Товара по каждой из Вариаций.
    ---*PRO-------------------------------------------------------------- */
	add_action ('woocommerce_product_after_variable_attributes', 'WooDecimalProductPro_quantity_product_after_variable_attributes', 10, 3);
	function WooDecimalProductPro_quantity_product_after_variable_attributes ($loop, $variation_data, $variation) {
        global $WooDecimalProduct_Min_Quantity_Default;
		global $WooDecimalProduct_Step_Quantity_Default;
		global $WooDecimalProduct_Item_Quantity_Default;
		global $WooDecimalProduct_Max_Quantity_Default;
				
		$Parent_ID = $variation->post_parent;
		$Product_ID = $variation->ID;
		
		// Min_Qnt
		$Min_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_min_qnt', true);
		
		if (!$Min_Qnt) {
			$Min_Qnt_Vario = get_post_meta ($Parent_ID, 'woodecimalproduct_min_qnt', true);
			if (!$Min_Qnt_Vario) {
				$Min_Qnt_Vario = $WooDecimalProduct_Min_Quantity_Default;
			}
		}
		
		// Step_Qnt
		$Step_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_step_qnt', true);
		
		if (!$Step_Qnt) {
			$Step_Qnt_Vario = get_post_meta ($Parent_ID, 'woodecimalproduct_step_qnt', true);
			if (!$Step_Qnt_Vario) {
				$Step_Qnt_Vario = $WooDecimalProduct_Step_Quantity_Default;
			}
		}	

		// Default_Qnt
		$Default_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_item_qnt', true);
		
		if (!$Default_Qnt) {
			$Default_Qnt_Vario = get_post_meta ($Parent_ID, 'woodecimalproduct_item_qnt', true);
			if (!$Default_Qnt_Vario) {
				$Default_Qnt_Vario = $WooDecimalProduct_Item_Quantity_Default;
			}
		}

		// Max_Qnt
		$Max_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_max_qnt', true);
		
		if (!$Max_Qnt) {
			$Max_Qnt_Vario = get_post_meta ($Parent_ID, 'woodecimalproduct_max_qnt', true);
			if (!$Max_Qnt_Vario) {
				$Max_Qnt_Vario = $WooDecimalProduct_Max_Quantity_Default;
			}
		}	
		
		ob_start();
		?>
		<div class="form-row form-row-full woodecimalproduct_options_variation_box">
			<p class="form-field woodecimalproduct_options_variation_field">
				<label for="woodecimalproduct_options_variation_field_min_qnt">Min cart Quantity (if the variation has a separate value)</label><input type="text" class="short" style="" name="woodecimalproduct_options_variation_field_min_qnt" id="woodecimalproduct_options_variation_field_min_qnt" value="<?php echo $Min_Qnt;?>" placeholder="<?php echo $Min_Qnt_Vario;?>">
			</p>
			
			<p class="form-field woodecimalproduct_options_variation_field">
				<label for="woodecimalproduct_options_variation_field_step_qnt">Step change Quantity (if the variation has a separate value)</label><input type="text" class="short" style="" name="woodecimalproduct_options_variation_field_step_qnt" id="woodecimalproduct_options_variation_field_step_qnt" value="<?php echo $Step_Qnt;?>" placeholder="<?php echo $Step_Qnt_Vario;?>">
			</p>

			<p class="form-field woodecimalproduct_options_variation_field">
				<label for="woodecimalproduct_options_variation_field_default_qnt">Default Quantity (if the variation has a separate value)</label><input type="text" class="short" style="" name="woodecimalproduct_options_variation_field_default_qnt" id="woodecimalproduct_options_variation_field_default_qnt" value="<?php echo $Default_Qnt;?>" placeholder="<?php echo $Default_Qnt_Vario;?>">
			</p>	

			<p class="form-field woodecimalproduct_options_variation_field">
				<label for="woodecimalproduct_options_variation_field_max_qnt">Max cart Quantity (if the variation has a separate value)</label><input type="text" class="short" style="" name="woodecimalproduct_options_variation_field_max_qnt" id="woodecimalproduct_options_variation_field_max_qnt" value="<?php echo $Max_Qnt;?>" placeholder="<?php echo $Max_Qnt_Vario;?>">
			</p>			
		</div>
		<?php
		$Buffer = ob_get_contents();		
		ob_end_clean();
		
		echo $Buffer;
	}	
	
    /* Вариативный Товар. Админка. Сохранение. Шаг и Минимальное кол-во выбора Товара на странице Товара по каждой из Вариаций.
    ---*PRO-------------------------------------------------------------- */	
	add_action ('woocommerce_save_product_variation', 'WooDecimalProductPro_save_product_variation', 10, 2);
	function WooDecimalProductPro_save_product_variation ($Variation_ID, $i) {	
		$Min_Qnt 		= isset($_POST['woodecimalproduct_options_variation_field_min_qnt']) ? sanitize_text_field($_POST['woodecimalproduct_options_variation_field_min_qnt']) : '';
		$Step_Qnt 		= isset($_POST['woodecimalproduct_options_variation_field_step_qnt']) ? sanitize_text_field($_POST['woodecimalproduct_options_variation_field_step_qnt']) : '';		
		$Default_Qnt 	= isset($_POST['woodecimalproduct_options_variation_field_default_qnt']) ? sanitize_text_field($_POST['woodecimalproduct_options_variation_field_default_qnt']) : '';		
		$Max_Qnt 		= isset($_POST['woodecimalproduct_options_variation_field_max_qnt']) ? sanitize_text_field($_POST['woodecimalproduct_options_variation_field_max_qnt']) : '';
		
		update_post_meta ($Variation_ID, 'woodecimalproduct_min_qnt', $Min_Qnt);
		update_post_meta ($Variation_ID, 'woodecimalproduct_step_qnt', $Step_Qnt);
		update_post_meta ($Variation_ID, 'woodecimalproduct_item_qnt', $Default_Qnt);
		update_post_meta ($Variation_ID, 'woodecimalproduct_max_qnt', $Max_Qnt);
	}		