<?php
/*
 * Decimal Product Quantity for WooCommerce PRO
 * ajax_processing.php
 */	 
	
	$Mode 			= isset($_REQUEST['mode']) ? sanitize_text_field($_REQUEST['mode']) : null;	
	$Product_ID 	= isset($_REQUEST['product_id']) ? sanitize_text_field($_REQUEST['product_id']) : null;
	$Variation_ID 	= isset($_REQUEST['variation_id']) ? sanitize_text_field($_REQUEST['variation_id']) : null;

	global $WooDecimalProduct_Min_Quantity_Default;
	global $WooDecimalProduct_Step_Quantity_Default;
	global $WooDecimalProduct_Item_Quantity_Default;
	global $WooDecimalProduct_Max_Quantity_Default;
	
	$Result = false; 

	// Get Variations
	if ($Mode == 'get_variation_args') {
		$Variation_Args = array();
		
		if ($Product_ID && $Variation_ID) {
			$Min_Qnt 		= get_post_meta ($Variation_ID, 'woodecimalproduct_min_qnt', true);
			$Max_Qnt 		= get_post_meta ($Variation_ID, 'woodecimalproduct_max_qnt', true);
			$Step_Qnt 		= get_post_meta ($Variation_ID, 'woodecimalproduct_step_qnt', true);					
			$Default_Qnt 	= get_post_meta ($Variation_ID, 'woodecimalproduct_item_qnt', true);

			// Min_Qnt.
			if (!$Min_Qnt) {
				$Min_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_min_qnt', true);
				
				if (!$Min_Qnt) {
					$Min_Qnt = $WooDecimalProduct_Min_Quantity_Default;
				}							
			}
			
			//Step_Qnt. 
			if (!$Step_Qnt) {
				$Step_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_step_qnt', true);
				
				if (!$Step_Qnt) {
					$Step_Qnt = $WooDecimalProduct_Step_Quantity_Default;
				}							
			}	

			// Default_Qnt.
			if (!$Default_Qnt) {
				$Default_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_item_qnt', true);
				
				if (!$Default_Qnt) {
					$Default_Qnt = $WooDecimalProduct_Item_Quantity_Default;
				}							
			}

			// Max_Qnt.			
			if (!$Max_Qnt) {
				$Max_Qnt = get_post_meta ($Product_ID, 'woodecimalproduct_max_qnt', true);
				
				if (!$Max_Qnt) {
					$Max_Qnt = $WooDecimalProduct_Max_Quantity_Default;
				}
			}
			
			// Precision
			$Locale_Info = localeconv();
			$Locale_Delimiter = $Locale_Info['decimal_point'];
			
			$Min_QNT_Precision = strlen (substr (strrchr ($Min_Qnt, $Locale_Delimiter), 1));
			$Def_QNT_Precision = strlen (substr (strrchr ($Default_Qnt, $Locale_Delimiter), 1));
			$Stp_QNT_Precision = strlen (substr (strrchr ($Step_Qnt, $Locale_Delimiter), 1));
			
			$QNT_Precision = max (array ($Min_QNT_Precision, $Def_QNT_Precision, $Stp_QNT_Precision));					
			
			$Variation_Args['product_id'] 	= $Product_ID;
			$Variation_Args['variation_id'] = $Variation_ID;
			$Variation_Args['min'] 			= $Min_Qnt;
			$Variation_Args['step'] 		= $Step_Qnt;					
			$Variation_Args['set'] 			= $Default_Qnt;
			$Variation_Args['max'] 			= $Max_Qnt;
			$Variation_Args['precision'] 	= $QNT_Precision;			
		}
		
		$Result = true;	
	}
	
	$Obj_Request = new stdClass();
	$Obj_Request->status 		= 'OK';
	$Obj_Request->answer 		= $Result;
	$Obj_Request->variation 	= $Variation_Args;

	wp_send_json($Obj_Request);    

	die; // Complete.